/*
 * n01_stats
 *
 * ImageList.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef	_INC_OLE
#include <commctrl.h>

#include "resource.h"

/* Define */
#define LICONSIZE			32
#define SICONSIZE			16

/* Global Variables */

// IvV

/* Local Function Prototypes */
static int imagelist_icon_add(const HINSTANCE hInstance, const HIMAGELIST icon_list, const int index);

/*
 * imagelist_icon_add - C[WXgɃACRǉ
 */
static int imagelist_icon_add(const HINSTANCE hInstance, const HIMAGELIST icon_list, const int index)
{
	HICON hIcon = NULL;
	int ret;

	hIcon = (HICON)LoadImage(hInstance, MAKEINTRESOURCE(index), IMAGE_ICON,
		SICONSIZE, SICONSIZE, 0);
	// C[WXgɃACRǉ
	ret = ImageList_AddIcon(icon_list, hIcon);
	DestroyIcon(hIcon);
	return ret;
}

/*
 * create_imagelist - C[WXg̍쐬
 */
HIMAGELIST create_imagelist(const HINSTANCE hInstance)
{
	HIMAGELIST icon_list;

	icon_list = ImageList_Create(SICONSIZE, SICONSIZE, ILC_COLOR16 | ILC_MASK, 0, 0);
	ImageList_SetBkColor(icon_list, GetSysColor(COLOR_WINDOW));

	imagelist_icon_add(hInstance, icon_list, IDI_ICON_DATA);
	imagelist_icon_add(hInstance, icon_list, IDI_ICON_DATA_M);
	imagelist_icon_add(hInstance, icon_list, IDI_ICON_ROOT);
	imagelist_icon_add(hInstance, icon_list, IDI_ICON_NAME);
	imagelist_icon_add(hInstance, icon_list, IDI_ICON_DATE);
	return icon_list;
}
/* End of source */
