/*
 * n01_stats
 *
 * data.h
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_DATA_H
#define _INC_DATA_H

/* Include Files */

/* Define */
typedef enum _HEADER_TYPE {
	HDTP_NAME = 0,
	HDTP_LINK_NAME,
	HDTP_VS_NAME,
	HDTP_DATE,
	HDTP_FILE_NAME,
	HDTP_START_SCORE,

	HDTP_SETS_PLAYED,
	HDTP_SETS_WON,
	HDTP_LEGS_PLAYED,
	HDTP_LEGS_WON,
	HDTP_TON,
	HDTP_TON00,
	HDTP_TON40,
	HDTP_TON80,
	HDTP_HIGH_OFF,
	HDTP_SHORT_GAME,
	HDTP_LONG_GAME,

	HDTP_AVG_SET,
	HDTP_AVG_LEG,
	HDTP_AVG_DARTS,
	HDTP_AVG_SCORE,
	HDTP_AVG_FIRST9,
	HDTP_AVG_CHECK_OUT,
	HDTP_AVG_CHECK_OUT_COUNT,
	HDTP_AVG_KEEP_LEGS,
	HDTP_AVG_KEEP_LEGS_COUNT,
	HDTP_AVG_BREAK_LEGS,
	HDTP_AVG_BREAK_LEGS_COUNT,

	HDTP_SUCCESS_2_80,
	HDTP_FAILURE_2_80,
	HDTP_SUCCESS_81_130,
	HDTP_FAILURE_81_130,
	HDTP_SUCCESS_131,
	HDTP_FAILURE_131,

	HDTP_AVG_CHECK_OUT_VIEW,
	HDTP_AVG_KEEP_LEGS_VIEW,
	HDTP_AVG_BREAK_LEGS_VIEW,

	HDTP_LEGS,
} HEADER_TYPE;

/* Struct */

/* Function Prototypes */
TCHAR *data_get_title(const int type);
TCHAR *data_to_value(const int type, const DATA_INFO *di, TCHAR *ret);

BOOL data_extract_check(const DATA_INFO *di);
BOOL data_marge_check(const DATA_INFO *di, const DATA_INFO *from_di);
BOOL data_create_stats(DATA_INFO *from_di, const int st, const int en, DATA_INFO *di, int *ret, const BOOL update);
int data_subtract_stats(DATA_INFO *from_di, const int st, const int en, DATA_INFO *di, int *ret);
BOOL data_split_data(const HWND hWnd, const TCHAR *split_str, const int split_delete, DATA_INFO **di, int *di_count, int *di_size, const int index);

BOOL data_show_data(const HWND hWnd, const DATA_INFO *di);
BOOL data_show_list(const HWND hWnd, const HWND lv_wnd, const DATA_INFO *di, const int di_count);

#endif
/* End of source */
