/*
 * n01_stats
 *
 * Ini.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE
#include <tchar.h>
#include <commctrl.h>

#include "General.h"
#include "Memory.h"
#include "String.h"
#include "Message.h"
#include "Profile.h"
#include "data.h"

#include "resource.h"

/* Define */

/* Global Variables */
extern OPTION op;

/* Local Function Prototypes */

/*
 * get_color - F擾
 */
static COLORREF get_color(const TCHAR *buf, const COLORREF def_color)
{
	if (*buf == TEXT('\0')) {
		return def_color;
	}
	return _tcstol(buf, NULL, 0);
}

/*
 * ini_get_option - IvV擾
 */
BOOL ini_get_option(const TCHAR *ini_path)
{
	HEADER_INFO hi[] = {
		{1, 0, HDTP_NAME, LVCFMT_LEFT, 100},
		{0, 0, HDTP_LINK_NAME, LVCFMT_LEFT, 100},
		{0, 0, HDTP_VS_NAME, LVCFMT_LEFT, 100},
		{0, 0, HDTP_LEGS, LVCFMT_LEFT, 50},
		{1, 0, HDTP_DATE, LVCFMT_LEFT, 130},
		{0, 0, HDTP_FILE_NAME, LVCFMT_LEFT, 100},
		{0, 0, HDTP_START_SCORE, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_AVG_SCORE, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_AVG_FIRST9, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_AVG_CHECK_OUT, LVCFMT_RIGHT, 60},
		{0, 0, HDTP_AVG_CHECK_OUT_COUNT, LVCFMT_LEFT, 70},
		{1, 0, HDTP_SETS_PLAYED, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_SETS_WON, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_LEGS_PLAYED, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_LEGS_WON, LVCFMT_RIGHT, 70},
		{0, 0, HDTP_TON, LVCFMT_RIGHT, 50},
		{1, 0, HDTP_TON00, LVCFMT_RIGHT, 50},
		{1, 0, HDTP_TON40, LVCFMT_RIGHT, 50},
		{1, 0, HDTP_TON80, LVCFMT_RIGHT, 50},
		{1, 0, HDTP_HIGH_OFF, LVCFMT_RIGHT, 60},
		{1, 0, HDTP_SHORT_GAME, LVCFMT_RIGHT, 60},
		{1, 0, HDTP_LONG_GAME, LVCFMT_RIGHT, 60},
		{1, 0, HDTP_AVG_SET, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_AVG_LEG, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_AVG_DARTS, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_AVG_KEEP_LEGS, LVCFMT_RIGHT, 60},
		{0, 0, HDTP_AVG_KEEP_LEGS_COUNT, LVCFMT_LEFT, 70},
		{1, 0, HDTP_AVG_BREAK_LEGS, LVCFMT_RIGHT, 60},
		{0, 0, HDTP_AVG_BREAK_LEGS_COUNT, LVCFMT_LEFT, 70},
		{1, 0, HDTP_SUCCESS_2_80, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_FAILURE_2_80, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_SUCCESS_81_130, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_FAILURE_81_130, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_SUCCESS_131, LVCFMT_RIGHT, 70},
		{1, 0, HDTP_FAILURE_131, LVCFMT_RIGHT, 70},
	};
	RECT rect;
	TCHAR buf[BUF_SIZE];
	int i;

	profile_initialize(ini_path, TRUE);

	SystemParametersInfo(SPI_GETWORKAREA, 0, &rect, 0);

	op.window_rect.left = profile_get_int(TEXT("window"), TEXT("left"), CW_USEDEFAULT, ini_path);
	op.window_rect.top = profile_get_int(TEXT("window"), TEXT("top"), CW_USEDEFAULT, ini_path);
	op.window_rect.right = profile_get_int(TEXT("window"), TEXT("right"), CW_USEDEFAULT, ini_path);
	op.window_rect.bottom = profile_get_int(TEXT("window"), TEXT("bottom"), CW_USEDEFAULT, ini_path);
	if (op.window_rect.left > rect.right || op.window_rect.top > rect.bottom) {
		op.window_rect.left = 0;
		op.window_rect.top = 0;
	}
	op.window_state = profile_get_int(TEXT("window"), TEXT("state"), SW_SHOWDEFAULT, ini_path);
	op.sep_size = profile_get_int(TEXT("window"), TEXT("sep_size"), 200, ini_path);

	op.lv_style = profile_get_int(TEXT("listview"), TEXT("lv_style"), LVS_REPORT | LVS_SHOWSELALWAYS, ini_path);
	op.lv_ex_style = profile_get_int(TEXT("listview"), TEXT("lv_ex_style"), LVS_EX_INFOTIP | LVS_EX_FULLROWSELECT | LVS_EX_HEADERDRAGDROP, ini_path);
	op.sort_colum = profile_get_int(TEXT("listview"), TEXT("sort_colum"), 0, ini_path);
	op.sort_order = profile_get_int(TEXT("listview"), TEXT("sort_order"), 0, ini_path);
	CopyMemory(op.hi, hi, sizeof(hi));
	op.hi_count = sizeof(hi) / sizeof(HEADER_INFO);
	for (i = 0; i < op.hi_count; i++) {
		wsprintf(buf, TEXT("show_%d"), hi[i].type);
		op.hi[i].show = profile_get_int(TEXT("listview"), buf, hi[i].show, ini_path);
		wsprintf(buf, TEXT("order_%d"), hi[i].type);
		op.hi[i].order = profile_get_int(TEXT("listview"), buf, i, ini_path);
		wsprintf(buf, TEXT("cx_%d"), hi[i].type);
		op.hi[i].cx = profile_get_int(TEXT("listview"), buf, hi[i].cx, ini_path);
	}

	profile_get_string(TEXT("data"), TEXT("csv_path"), TEXT(""), op.csv_path, MAX_PATH - 1, ini_path);
	op.csv_path_default = profile_get_int(TEXT("data"), TEXT("csv_path_default"), 0, ini_path);
	op.csv_update = profile_get_int(TEXT("data"), TEXT("csv_update"), 1, ini_path);
	op.delete_type = profile_get_int(TEXT("data"), TEXT("delete_type"), 0, ini_path);
	op.extract_type = profile_get_int(TEXT("data"), TEXT("extract_type"), EXTRACT_TYPE_NAME, ini_path);
	profile_get_string(TEXT("data"), TEXT("split_sep"), TEXT("-"), op.split_sep, BUF_SIZE - 1, ini_path);
	op.split_delete = profile_get_int(TEXT("data"), TEXT("split_delete"), 0, ini_path);
	op.auto_split = profile_get_int(TEXT("data"), TEXT("auto_split"), 0, ini_path);
	profile_get_string(TEXT("data"), TEXT("auto_split_sep"), TEXT("-"), op.auto_split_sep, BUF_SIZE - 1, ini_path);
	op.auto_split_delete = profile_get_int(TEXT("data"), TEXT("auto_split_delete"), 0, ini_path);

	// XRAꗗ
	op.score_list_rect.left = profile_get_int(TEXT("score_list"), TEXT("left"), 0, ini_path);
	op.score_list_rect.top = profile_get_int(TEXT("score_list"), TEXT("top"), 0, ini_path);
	op.score_list_rect.right = profile_get_int(TEXT("score_list"), TEXT("right"), 0, ini_path);
	op.score_list_rect.bottom = profile_get_int(TEXT("score_list"), TEXT("bottom"), 0, ini_path);
	if (op.score_list_rect.left > rect.right || op.score_list_rect.top > rect.bottom) {
		op.score_list_rect.left = 0;
		op.score_list_rect.top = 0;
	}
	profile_get_string(TEXT("score_list"), TEXT("font"), message_get_res(IDS_STRING_DEFAULT_FONT), op.score_list_font, BUF_SIZE - 1, ini_path);

	profile_free();
	return TRUE;
}

/*
 * ini_put_option - IvV
 */
BOOL ini_put_option(const TCHAR *ini_path)
{
	TCHAR buf[BUF_SIZE];
	int i;

	profile_initialize(ini_path, TRUE);

	profile_write_int(TEXT("window"), TEXT("left"), op.window_rect.left, ini_path);
	profile_write_int(TEXT("window"), TEXT("top"), op.window_rect.top, ini_path);
	profile_write_int(TEXT("window"), TEXT("right"), op.window_rect.right, ini_path);
	profile_write_int(TEXT("window"), TEXT("bottom"), op.window_rect.bottom, ini_path);
	profile_write_int(TEXT("window"), TEXT("state"), op.window_state, ini_path);
	profile_write_int(TEXT("window"), TEXT("sep_size"), op.sep_size, ini_path);

	profile_write_int(TEXT("listview"), TEXT("lv_style"), op.lv_style, ini_path);
	profile_write_int(TEXT("listview"), TEXT("lv_ex_style"), op.lv_ex_style, ini_path);
	profile_write_int(TEXT("listview"), TEXT("sort_colum"), op.sort_colum, ini_path);
	profile_write_int(TEXT("listview"), TEXT("sort_order"), op.sort_order, ini_path);
	for (i = 0; i < op.hi_count; i++) {
		wsprintf(buf, TEXT("show_%d"), op.hi[i].type);
		profile_write_int(TEXT("listview"), buf, op.hi[i].show, ini_path);
		wsprintf(buf, TEXT("order_%d"), op.hi[i].type);
		profile_write_int(TEXT("listview"), buf, op.hi[i].order, ini_path);
		wsprintf(buf, TEXT("cx_%d"), op.hi[i].type);
		profile_write_int(TEXT("listview"), buf, op.hi[i].cx, ini_path);
	}

	profile_write_string(TEXT("data"), TEXT("csv_path"), op.csv_path, ini_path);
	profile_write_int(TEXT("data"), TEXT("csv_path_default"), op.csv_path_default, ini_path);
	profile_write_int(TEXT("data"), TEXT("csv_update"), op.csv_update, ini_path);
	profile_write_int(TEXT("data"), TEXT("delete_type"), op.delete_type, ini_path);
	profile_write_int(TEXT("data"), TEXT("extract_type"), op.extract_type, ini_path);
	profile_write_string(TEXT("data"), TEXT("split_sep"), op.split_sep, ini_path);
	profile_write_int(TEXT("data"), TEXT("split_delete"), op.split_delete, ini_path);
	profile_write_int(TEXT("data"), TEXT("auto_split"), op.auto_split, ini_path);
	profile_write_string(TEXT("data"), TEXT("auto_split_sep"), op.auto_split_sep, ini_path);
	profile_write_int(TEXT("data"), TEXT("auto_split_delete"), op.auto_split_delete, ini_path);

	// XRAꗗ
	profile_write_int(TEXT("score_list"), TEXT("left"), op.score_list_rect.left, ini_path);
	profile_write_int(TEXT("score_list"), TEXT("top"), op.score_list_rect.top, ini_path);
	profile_write_int(TEXT("score_list"), TEXT("right"), op.score_list_rect.right, ini_path);
	profile_write_int(TEXT("score_list"), TEXT("bottom"), op.score_list_rect.bottom, ini_path);

	profile_flush(ini_path);
	profile_free();
	return TRUE;
}
/* End of source */
