/*
 * n01_stats
 *
 * output.c
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

/* Include Files */
#define _INC_OLE
#include <windows.h>
#undef  _INC_OLE

#include "General.h"

#include "resource.h"

/* Define */

/* Global Variables */

/* Local Function Prototypes */
static BOOL enum_file_list(const HWND hList, const TCHAR *path, const TCHAR *ptn);
static BOOL CALLBACK output_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

/*
 * enum_file_list - t@C̗
 */
static BOOL enum_file_list(const HWND hList, const TCHAR *path, const TCHAR *ptn)
{
	WIN32_FIND_DATA find_data;
	HANDLE h_find_file;
	TCHAR find_path[MAX_PATH];

	wsprintf(find_path, TEXT("%s\\%s"), path, ptn);
	if ((h_find_file = FindFirstFile(find_path, &find_data)) == INVALID_HANDLE_VALUE) {
		return FALSE;
	}
	do {
		if (find_data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
			continue;
		}
		SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)find_data.cFileName);
	} while (FindNextFile(h_find_file, &find_data) == TRUE);
	FindClose(h_find_file);
	return TRUE;
}

/*
 * output_proc - EBhEvV[W
 */
static BOOL CALLBACK output_proc(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam)
{
	TCHAR *path;
	TCHAR buf[BUF_SIZE];

	switch (msg) {
	case WM_INITDIALOG:
		if ((path = (TCHAR *)lParam) == NULL) {
			EndDialog(hDlg, FALSE);
			break;
		}
		SetWindowLong(hDlg, GWL_USERDATA, lParam);
		// t@C
		enum_file_list(GetDlgItem(hDlg, IDC_LIST_FILE), path, TEXT("*.exe"));
		enum_file_list(GetDlgItem(hDlg, IDC_LIST_FILE), path, TEXT("*.xls"));
		enum_file_list(GetDlgItem(hDlg, IDC_LIST_FILE), path, TEXT("*.vbs"));
		enum_file_list(GetDlgItem(hDlg, IDC_LIST_FILE), path, TEXT("*.lnk"));
		enum_file_list(GetDlgItem(hDlg, IDC_LIST_FILE), path, TEXT("*.bat"));
		// ԏIԂɂ
		SendDlgItemMessage(hDlg, IDC_LIST_FILE, LB_SETCURSEL, 0, 0);
		break;

	case WM_CLOSE:
		EndDialog(hDlg, FALSE);
		break;

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDC_LIST_FILE:
			if (HIWORD(wParam) == LBN_DBLCLK) {
				SendMessage(hDlg, WM_COMMAND, IDOK, 0);
			}
			break;

		case IDOK:
			path = (TCHAR *)GetWindowLong(hDlg, GWL_USERDATA);
			if (path == NULL) {
				EndDialog(hDlg, FALSE);
				break;
			}
			if (SendDlgItemMessage(hDlg, IDC_LIST_FILE, LB_GETCURSEL, 0, 0) == -1) {
				break;
			}
			SendDlgItemMessage(hDlg, IDC_LIST_FILE, LB_GETTEXT, SendDlgItemMessage(hDlg, IDC_LIST_FILE, LB_GETCURSEL, 0, 0), (LPARAM)buf);
			lstrcat(path, TEXT("\\"));
			lstrcat(path, buf);
			EndDialog(hDlg, TRUE);
			break;

		case IDCANCEL:
			SendMessage(hDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	default:
		return FALSE;
	}
	return TRUE;
}

/*
 * show_output - o͕@Iʕ\
 */
BOOL show_output(const HINSTANCE hInst, const HWND hWnd, TCHAR *path)
{
	return DialogBoxParam(hInst, MAKEINTRESOURCE(IDD_DIALOG_OUTPUT), hWnd, output_proc, (LPARAM)path);
}
/* End of source */
